package com.tofly.spire.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.spire.entity.SpireUser;
import com.tofly.spire.entity.dto.SpireUserDto;

import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;

/**
 * 小表（户表）(SpireUser)表服务接口
 *
 * @author HaiQiu
 * @since 2022-11-11 13:22:39
 */
public interface SpireUserService extends IService<SpireUser> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    SpireUser get(Serializable id);

    /**
     * 新增
     *
     * @param spireUserDto 实体
     */
    void insert(SpireUserDto spireUserDto);

    /**
     * 修改
     *
     * @param spireUserDto 实体
     */
    void edit(SpireUserDto spireUserDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page      分页
     * @param spireUser 查询wrapper
     * @return 数据集合
     */
    Page<SpireUser> pageList(Page page, SpireUser spireUser);

    /**
     * 数据导出
     *
     * @param page      分页
     * @param spireUser 查询模型
     * @param isAll     是否导出全部数据，true是，false否
     */
    void export(Page page, SpireUser spireUser, Boolean isAll);

    /**
     * 查询所有数据
     *
     * @param spireUser 查询条件
     * @return 查询所有数据
     */
    List<SpireUser> allList(SpireUser spireUser);

    long getUserInfoData();
}

